;; um/mod
;;
;; ( ud u1 -- u2 u3 )
;;
;; unsigned 32/16 -> 16r16 divide

link_
.db "um/mod",0,0

umslashmod:
  ; load dividend
  ld temp2,y+
  ld temp3,y+
  ld temp0,y+
  ld temp1,y+

  ; set loop counter
  ldi xl,$10

umslashmod_loop:
  ; shift left, saving high bit
  clr xh
  lsl temp0
  rol temp1
  rol temp2
  rol temp3
  rol xh

  ; try subtracting divisor
  cp temp2,tosl
  cpc temp3,tosh
  cpc xh,zero

  brcs umslashmod_loop_control

umslashmod_subtract:
  ; dividend is large enough
  ; do the subtraction for real
  ; and set lowest bit
  inc temp0
  sub temp2,tosl
  sbc temp3,tosh

umslashmod_loop_control:
  dec xl
  brne umslashmod_loop

umslashmod_done:
  ; put remainder on stack
  st -y,temp3
  st -y,temp2

  ; put quotient on stack
  movw tos,temp0
  ret

